Index: app/helpers/application_helper.rb
===================================================================
--- app/helpers/application_helper.rb	(revision 3038)
+++ app/helpers/application_helper.rb	(working copy)
@@ -161,6 +161,22 @@
       s
     end
   end
+
+	def render_project_mega_dropdown
+		projects = User.current.projects.all
+		if projects.any?
+			s = '<ul id="project_dropdown">' +
+						'<li class="dropdown">'+
+						"<h2><a href='#'>#{ l(:label_jump_to_a_project) }</h2>"+
+						"<div>"
+			projects.each do |p|
+				s << '<a href="'+ url_for(:controller => 'projects', :action => 'show', :id => p) + '">' + p.name + '</a><br />'
+      end		
+			s << '</div>'
+			s << '</li>'
+			s << '</ul>'
+		end
+	end
   
   def project_tree_options_for_select(projects, options = {})
     s = ''
Index: app/views/layouts/base.rhtml
===================================================================
--- app/views/layouts/base.rhtml	(revision 3038)
+++ app/views/layouts/base.rhtml	(working copy)
@@ -6,7 +6,28 @@
 <meta name="description" content="<%= Redmine::Info.app_name %>" />
 <meta name="keywords" content="issue,bug,tracker" />
 <%= stylesheet_link_tag 'application', :media => 'all' %>
-<%= javascript_include_tag :defaults %>
+<%= javascript_include_tag :defaults, 'jquery', 'jquery.hoverintent' %>
+<script language="Javascript">
+	$(document).ready(function() {		
+		function addDropdown(){
+			$(this).addClass("hovering");
+			}
+
+		function removeDropdown(){
+			$(this).removeClass("hovering");
+			}
+
+	var dropdownConfig = {
+			 interval: 250,
+			 sensitivity: 4,
+			 over: addDropdown,
+			 timeout: 500,
+			 out: removeDropdown
+	};
+
+	$("li.dropdown").hoverIntent(dropdownConfig)
+	});
+</script>
 <%= heads_for_wiki_formatter %>
 <!--[if IE]>
     <style type="text/css">
@@ -30,12 +51,12 @@
       
 <div id="header">
     <div id="quick-search">
+        <%= render_project_mega_dropdown %>
         <% form_tag({:controller => 'search', :action => 'index', :id => @project}, :method => :get ) do %>
         <%= hidden_field_tag(controller.default_search_scope, 1, :id => nil) if controller.default_search_scope %>
         <%= link_to l(:label_search), {:controller => 'search', :action => 'index', :id => @project}, :accesskey => accesskey(:search) %>:
         <%= text_field_tag 'q', @question, :size => 20, :class => 'small', :accesskey => accesskey(:quick_search) %>
-        <% end %>
-        <%= render_project_jump_box %>
+        <% end %>        
     </div>
     
     <h1><%= page_header_title %></h1>
Index: public/stylesheets/application.css
===================================================================
--- public/stylesheets/application.css	(revision 3038)
+++ public/stylesheets/application.css	(working copy)
@@ -808,3 +808,19 @@
   #content { width: 99%; margin: 0; padding: 0; border: 0; background: #fff; overflow: visible !important;}
 	#wiki_add_attachment { display:none; }
 }
+
+#project_dropdown { float: left; margin: 0; padding: 0.3em 0em; }
+#project_dropdown li { -webkit-box-shadow: 0.25em 0.25em 1em rgba(0,0,0,0.25); -moz-box-shadow: rgba(0,0,0,0.25) 0.25em 0.25em 1em;	background: #f6f6f6; padding: 0.5em 1.5em; border-radius: 1em; position: relative; display: inline; margin: 0.1em 1em; }
+#project_dropdown h2, ul h3 { font-size: 100%; font-weight: normal; display: inline; }
+#project_dropdown li a { color: #000; text-decoration: none; padding: 0 0.4em; }
+#project_dropdown li a:hover { text-decoration: none; }
+#project_dropdown li.dropdown a { background: transparent url(arrow.gif) center right no-repeat; padding: 0 1.2em; }
+#project_dropdown li.dropdown a:hover { text-decoration: none; }
+#project_dropdown div { display: none; }
+#project_dropdown li.dropdown div { background: #f6f6f6; border-radius: 1em; border-color: #e4e4e4;	-webkit-box-shadow: 0.25em 0.25em 1em rgba(0,0,0,0.25);	-moz-box-shadow: rgba(0,0,0,0.25) 0.25em 0.25em 1em; position: absolute;	color: #f1938c;	padding: 1.5em 2em;	 z-index: 10;	 min-width: 18em;	right: -10px;	padding-top: 2em; }
+#project_dropdown li.hovering div { display: block; }
+#project_dropdown li.dropdown div a { color: #333; padding: 0; background-image: none; }
+#project_dropdown li.dropdown div a:hover { text-decoration: underline; }
+#project_dropdown li div a.more { font-weight: bold; }
+#project_dropdown div h3 { font-weight: bold; font-size: 1.1em; }
+#project_dropdown div p { margin: 0 0 0.8em 0; padding: 0; }